# Script to read some counters directly from trace and output the bandwidth and the Flop/Byte metric.
#!/usr/bin/python
import sys
import os
import numpy as np

def h():
   print "Argument must be a single .prv file"
   exit(0)

if not (len(sys.argv) == 2 ):
   h()

filename = sys.argv[1]

assert os.path.isfile(filename), "Is not a file"
assert filename.count(".prv") == 1, "Not a .prv file"

loads=[]
stores=[]
total_cycles=[]
FpO=[]
with open(filename,"r") as f:
   for line in f:
      if line.count("60000519:0:"):
         splitted = line.split(":")
         for index, element in enumerate(splitted):
            if element == "42000059":
               total_cycles.append(int(splitted[index+1]))
            if element == "42000053":
               loads.append(int(splitted[index+1]))
            if element == "42000054":
               stores.append(int(splitted[index+1]))
            if element == "42000104":
               FpO.append(int(splitted[index+1]))

if len(loads) > 1:
   LD = np.average(loads)
else:
   LD = loads[0]

if len(stores) > 1:
   SR = np.average(stores)
else:
   SR = stores[0]

if len(total_cycles) > 1:
   TOT_CYC = np.average(total_cycles)
else:
   TOT_CYC = total_cycles[0]


FpOs = np.average(FpO)
print "%.3f" % (32*(LD+SR)/(TOT_CYC*1.)), FpOs/(32.*LD+32.*SR)
